#pragma once

#include "Definitions.h"
#include "FFT.h"
#include "CommandReader.h"
#include "AudioQueue.h"
#include "Mmsystem.h"

static const int DTMFHigh[4]=
{
	BIN4,
	BIN5,
	BIN6,
	BIN7
};

static const int DTMFLow[4]=
{
	BIN0,
	BIN1,
	BIN2,
	BIN3
};

static const char ToneDecode[4][4]=
{
	{'1','2','3','A'},
	{'4','5','6','B'},
	{'7','8','9','C'},
	{'*','0','#','D'}
};

static bool singleton = false;

class AFX_EXT_CLASS AudioMonitor
{
public:
	AudioMonitor(CommandReader* in, int myDevice);
	AudioMonitor(HWND win, CString device);
	~AudioMonitor(void);
	void Quit();
	static void CALLBACK WaveCallback( HWAVEIN waveIn, UINT Msg, DWORD_PTR Callback, DWORD_PTR Param1, DWORD_PTR Param2 );
	static void ThreadFunc();
private:
	bool clean;
	static CommandReader* myReader;
	static AudioQueue* queue;
	static FFT* myFFT;
	static bool quit;
	static int threshold;
	static HWAVEIN wavdev;
	static HANDLE myThread;
};
