#include "StdAfx.h"
#include "CommandReader.h"
#include <time.h>

CommandReader::CommandReader(HWND win)
{
	parent = win;
}

CommandReader::~CommandReader(void)
{
}

void CommandReader::Ping(){
	LPCTSTR out = command;
	::SendMessage( parent, WM_COMMANDMSG, (WPARAM)out, 0 );
}

bool CommandReader::Valid(){
	bool ret = false;
	if( (command[0] == '#')||(command[0] == '*') ){
		ret = true;
	}
	return ret;
}

void CommandReader::ProcessChar( char in ){
	if( in == '#' ){
		command = "#";
		time( &lastCommand );
	}else{
		if( in == '*' ){
			command = "*";
			time( &lastCommand );
		}else{
			if( command.GetLength() <= MAXLENGTH ){
				time_t now;
				time( &now );
				if( (now - lastCommand) > MAXTIME ){
					command = "";
				}
				command += in;
				time( &lastCommand );
			}else{
				command = "";
				command += in;
				time( &lastCommand );
			}
		}
	}
	if( Valid() ){
		Ping();
	}
}
