#pragma once
/**
 * Message definitions
 */

#define WM_CHARFOUND	WM_USER+1
#define WM_COMMANDMSG	WM_USER+2

/**
 * Audio definitions
 */
#define NUMCHANNELS 1
#define SAMPLESPERSEC 11025
#define BITSPERSAMPLE 16
#define BLOCKALIGN  ((NUMCHANNELS * BITSPERSAMPLE)/8)
#define AVGBYTESPERSEC (BLOCKALIGN * SAMPLESPERSEC)

#define BINS 256
#define TIMEBUFFER 1
#define NUMBUFFERS (TIMEBUFFER * SAMPLESPERSEC / BINS)
#define BUFFERSIZE (BINS * BLOCKALIGN)

#define BINSIZE ((double)SAMPLESPERSEC/BINS)

/**
 * DTMF tone values in Hz
 */
#define TONE0 697
#define TONE1 770
#define TONE2 852
#define TONE3 941
#define TONE4 1209
#define TONE5 1336
#define TONE6 1477
#define TONE7 1633

/**
 * DTMF Bin addresses
 */
#define BIN0 ((int)((TONE0/BINSIZE) + .5))
#define BIN1 ((int)((TONE1/BINSIZE) + .5))
#define BIN2 ((int)((TONE2/BINSIZE) + .5))
#define BIN3 ((int)((TONE3/BINSIZE) + .5))
#define BIN4 ((int)((TONE4/BINSIZE) + .5))
#define BIN5 ((int)((TONE5/BINSIZE) + .5))
#define BIN6 ((int)((TONE6/BINSIZE) + .5))
#define BIN7 ((int)((TONE7/BINSIZE) + .5))

#define BINHMIN BIN4
#define BINHMAX BIN7
#define BINLMIN BIN0
#define BINLMAX BIN3

#define MAXLENGTH 20
#define MAXTIME 30